/* R[h͂rihr sR[h͂bqke */
/* $Id: ImasMultiColorKeying.h 6 2008-07-17 15:01:34Z umezawa $ */
/*
 * iM@S MultiColor Keying
 * Copyright (C) 2008  UMEZAWA Takeshi
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * 
 * iM@S MultiColor Keying
 * Copyright (C) 2008  ~V Ўu
 * 
 * ̃vO̓t[\tgEFAłBȂ͂At[\t
 * gEFAcɂĔsꂽ GNU ʌOp_(o[W
 * 2A]ɂĂ͂ȍ~̃o[Ŵǂꂩ)̒߂
 * ̉ōĔЕz܂͉ς邱Ƃł܂B
 * 
 * ̃vO͗Lpł邱ƂĔЕz܂A*S̖
 * * łBƉ\̕ۏ؂̖ړIւ̓ḰAOɎꂽ
 * ̂܂ߑS݂܂BڂGNU ʌOp_񏑂
 * B
 * 
 * Ȃ͂̃vOƋɁAGNU ʌOp_񏑂̕
 * ꕔ󂯎͂łB󂯎ĂȂ΁At[\tgEF
 * Ac܂ŐĂ( the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA)B
 */

#pragma once

#include <avisynth.h>

class ImasMultiColorKeying :
	public GenericVideoFilter
{
protected:
	const PClip clip_r1;
	const PClip clip_r2;
	const PClip clip_r3;
	const PClip clip_g1;
	const PClip clip_g2;
	const PClip clip_g3;

public:
	static AVSValue __cdecl GetObject(AVSValue args, void *user_data, IScriptEnvironment *env);
	ImasMultiColorKeying(PClip _clip_r1, PClip _clip_r2, PClip _clip_r3, PClip _clip_g1, PClip _clip_g2, PClip _clip_g3, IScriptEnvironment *env);
	virtual ~ImasMultiColorKeying();

public:
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};
